; $Id$
;  AOcrayon - Chat color management tool for Anarchy Online
;  Copyright (C) 2005 - 2010  Mawerick
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; version 2 of the License.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
;

;---------------------------------------
;include Modern UI

  !include "MUI2.nsh"

;---------------------------------------
;General

  ;Name and file
  Name "GUISelect"
  OutFile "..\\..\\_Releases\\GUISelect\\GUISelect-1.1.1.exe"

  ;Default install folder
  InstallDir $PROGRAMFILES\WrongPlace.Net\GUISelect

  ;Get install folder from registry if available
  InstallDirRegKey HKLM "Software\WrongPlace.Net\GUISelect" "InstallPath"

  ;Request app priveleges (Vista)
  RequestExecutionLevel user

  SetCompressor lzma

;---------------------------------------
;Variables

  Var StartMenuFolder

;--------------------------------
;Version Information

  VIProductVersion "1.1.1.0"
  VIAddVersionKey "ProductName" "GUISelect"
  VIAddVersionKey "Comments" "Anarchy Online GUI selection tool."
  VIAddVersionKey "CompanyName" "WrongPlace.Net"
  VIAddVersionKey "LegalCopyright" " Mawerick, WrongPlace.Net 2009 - 2010"
  VIAddVersionKey "FileDescription" "GUISelect Installer"
  VIAddVersionKey "FileVersion" "1.1.1.0"

;---------------------------------------
;Interface settings

  !define MUI_HEADERIMAGE
  !define MUI_HEADERIMAGE_BITMAP "installer.bmp"
  !define MUI_ABORTWARNING
  !define MUI_FINISHPAGE_NOAUTOCLOSE

;---------------------------------------
;Pages

  !insertmacro MUI_PAGE_LICENSE "D:\Workspace\GUISelect\dist\GPLv3_License.txt"
  !insertmacro MUI_PAGE_DIRECTORY

  ;Start Menu Folder Page Configuration
  !define MUI_STARTMENUPAGE_REGISTRY_ROOT "HKCU"
  !define MUI_STARTMENUPAGE_REGISTRY_KEY "Software\WrongPlace.Net\GUISelect"
  !define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "Start Menu Folder"
  !define MUI_STARTMENUPAGE_DEFAULTFOLDER "WrongPlace.Net\GUISelect"
  !insertmacro MUI_PAGE_STARTMENU Application $StartMenuFolder

  !insertmacro MUI_PAGE_INSTFILES

  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
 
  ;Finish Page Configuration
  !define MUI_FINISHPAGE_RUN $INSTDIR\GUISelect.exe
  !define MUI_FINISHPAGE_RUN_TEXT "Run GUISelect now."
  !insertmacro MUI_PAGE_FINISH

;---------------------------------------
;Languages

  !insertmacro MUI_LANGUAGE "English"

;---------------------------------------
;Functions
Function RemoveOldInstall
  ReadRegStr $0 HKCU "SOFTWARE\WrongPlace.Net\GUISelect" "InstallPath"

  IfFileExists "$0\uninstall.exe" 0 +2
    ExecWait '"$0\uninstall.exe" /S _?=$0'

  ReadRegStr $0 HKCU "SOFTWARE\GUISelect" "InstallPath"

  IfFileExists "$0\uninstall.exe" 0 +2
    ExecWait '"$0\uninstall.exe" /S _?=$0'

FunctionEnd

;---------------------------------------
;Installer sections
Section "Installer" SecInstall

  SectionIn RO

  Call RemoveOldInstall

  SetOutPath $INSTDIR
  File "D:\Workspace\GUISelect\bin\Release\GUISelect.exe"
  File "D:\Workspace\GUISelect\bin\Release\Twp.Utilities.dll"
  File "D:\Workspace\GUISelect\dist\ChangeLog.txt"
  File "D:\Workspace\GUISelect\dist\Readme.txt"
  File "D:\Workspace\GUISelect\dist\GPLv3_License.txt"

  ;Store install folder
  WriteRegStr HKCU "SOFTWARE\WrongPlace.Net\GUISelect" "InstallPath" "$INSTDIR"

  ;Create uninstaller
  WriteUninstaller "$INSTDIR\uninstall.exe"

  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application

    ;Create shortcuts
    CreateDirectory "$SMPROGRAMS\$StartMenuFolder"
    CreateShortCut "$SMPROGRAMS\$StartMenuFolder\GUISelect.lnk" "$INSTDIR\GUISelect.exe"
    CreateShortCut "$SMPROGRAMS\$StartMenuFolder\ChangeLog.lnk" "$INSTDIR\ChangeLog.txt"
    CreateShortCut "$SMPROGRAMS\$StartMenuFolder\Readme.lnk" "$INSTDIR\Readme.txt"
    CreateShortCut "$SMPROGRAMS\$StartMenuFolder\License.lnk" "$INSTDIR\GPLv3_License.txt"
    CreateShortCut "$SMPROGRAMS\$StartMenuFolder\Uninstall.lnk" "$INSTDIR\Uninstall.exe"

  !insertmacro MUI_STARTMENU_WRITE_END

SectionEnd

;---------------------------------------
;Uninstaller section
Section "Uninstall"

  ;Delete files and folders
  Delete "$INSTDIR\*.*"
  RMDir "$INSTDIR"

  ;Delete startmenu folder
  !insertmacro MUI_STARTMENU_GETFOLDER Application $StartMenuFolder
  Delete "$SMPROGRAMS\$StartMenuFolder\*.*"
  RMDir "$SMPROGRAMS\$StartMenuFolder"

  DeleteRegKey HKCU "Software\WrongPlace.Net\GUISelect"
  DeleteRegKey /ifempty HKCU "Software\WrongPlace.Net"

SectionEnd

; vim: ts=2 sw=2 et:
