//
//  Copyright (C) 2009 Mawerick
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
using System;
using System.IO;

using Twp.Utilities;

namespace GUISelect
{
	public class Settings
	{
		private IniDocument doc = new IniDocument( "GUISelect.ini" );

		public string AOPath
		{
			get { return this.doc.Groups["General"]["AOPath"]; }
			set { this.doc.Groups["General"]["AOPath"] = value; }
		}

		public bool SetSkin
		{
			get { return Convert.ToBoolean( this.doc.Groups["General"]["SetSkin"] ); }
			set { this.doc.Groups["General"]["SetSkin"] = value.ToString(); }
		}

		public void Load()
		{
			try
			{
				this.doc.Read();
			}
			catch( FileNotFoundException ex )
			{
				Log.Debug( "[Settings] [Load]", ex.Message );
			}
			catch( IniParseException ex )
			{
				Log.Warning( ex.Message );
				Log.Debug( "[Settings] [Load]", ex.Line );
			}
			this.doc.SetDefault( "General", "AOPath", String.Empty );
			this.doc.SetDefault( "General", "SetSkin", "true" );
		}

		public void Save()
		{
			try
			{
				this.doc.Write();
			}
			catch( Exception ex )
			{
				ExceptionDialog.Show( ex );
			}
		}
	}
}
